# Interface DocSourcePositions

All Superinterfaces:
  `SourcePositions`

public interface DocSourcePositions extends SourcePositions
Provides methods to obtain the position of a DocTree within a javadoc comment. A position is defined as a simple character offset from the start of a CompilationUnit where the first character is at offset 0.

Since:
  1.8

## Method Summary

Modifier and Type
Method
Description
`long`
`getEndPosition(DocCommentTree comment, DocTree tree)`
Returns the ending position of the given `Tree`. If the ending position is not available, returns `Diagnostic.NOPOS`.
`default long`
`getEndPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)`
Deprecated, for removal: This API element is subject to removal in a future version.
use `getEndPosition(DocCommentTree, DocTree)` instead
`long`
`getStartPosition(DocCommentTree comment, DocTree tree)`
Returns the starting position of the given `Tree`. If the starting position is not available, returns `Diagnostic.NOPOS`.
`default long`
`getStartPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)`
Deprecated, for removal: This API element is subject to removal in a future version.
use `getStartPosition(DocCommentTree, DocTree)` instead

### Methods declared in interface SourcePositions

`getEndPosition, getEndPosition, getStartPosition, getStartPosition`
Modifier and Type
Method
Description
`default long`
`getEndPosition(CompilationUnitTree file, Tree tree)`
Deprecated, for removal: This API element is subject to removal in a future version.
use `SourcePositions.getEndPosition(Tree)` instead
`long`
`getEndPosition(Tree tree)`
Returns the ending position of the given `Tree`. If the ending position is not available, returns `Diagnostic.NOPOS`.
`default long`
`getStartPosition(CompilationUnitTree file, Tree tree)`
Deprecated, for removal: This API element is subject to removal in a future version.
use `SourcePositions.getStartPosition(Tree)` instead
`long`
`getStartPosition(Tree tree)`
Returns the starting position of the given `Tree`, or if the starting position is not available, returns `Diagnostic.NOPOS`.

## Method Details

### getStartPosition

@Deprecated(since="27", forRemoval=true) default long getStartPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)
Deprecated, for removal: This API element is subject to removal in a future version.
use `getStartPosition(DocCommentTree, DocTree)` instead
Returns the starting position of the tree within the comment within the file. If tree is not found within file, or if the starting position is not available, returns `Diagnostic.NOPOS`. The given tree should be under the given comment tree, and the given documentation comment tree should be returned from a `DocTrees.getDocCommentTree(com.sun.source.util.TreePath)` for a tree under the given file. The returned position must be at the start of the yield of this tree, that is for any sub-tree of this tree, the following must hold:

`getStartPosition(file, comment, tree) <= getStartPosition(file, comment, subtree)` or
`getStartPosition(file, comment, tree) == NOPOS` or
`getStartPosition(file, comment, subtree) == NOPOS`

Parameters:
  `file` - compilation unit in which to find tree
  `comment` - the comment tree that encloses the tree for which the position is being sought
  `tree` - tree for which a position is sought
Returns:
  the start position of tree

### getStartPosition

long getStartPosition(DocCommentTree comment, DocTree tree)
Returns the starting position of the given `Tree`. If the starting position is not available, returns `Diagnostic.NOPOS`.

The given tree should be under the given comment tree. The returned position must be at the start of the yield of this tree, that is for any sub-tree of this tree, the following must hold:

`getStartPosition(comment, tree) <= getStartPosition(comment, subtree)` or
`getStartPosition(comment, tree) == NOPOS` or
`getStartPosition(comment, subtree) == NOPOS`

Parameters:
  `comment` - the comment tree that encloses the tree for which the position is being sought
  `tree` - tree for which a position is sought
Returns:
  the starting position of the given `Tree`. If the starting position is not available, returns `Diagnostic.NOPOS`
Since:
  27

### getEndPosition

@Deprecated(since="27", forRemoval=true) default long getEndPosition(CompilationUnitTree file, DocCommentTree comment, DocTree tree)
Deprecated, for removal: This API element is subject to removal in a future version.
use `getEndPosition(DocCommentTree, DocTree)` instead
Returns the ending position of the tree within the comment within the file. If tree is not found within file, or if the ending position is not available, returns `Diagnostic.NOPOS`. The given tree should be under the given comment tree, and the given documentation comment tree should be returned from a `DocTrees.getDocCommentTree(com.sun.source.util.TreePath)` for a tree under the given file. The returned position must be at the end of the yield of this tree, that is for any sub-tree of this tree, the following must hold:

`getEndPosition(file, comment, tree) >= getEndPosition(file, comment, subtree)` or
`getEndPosition(file, comment, tree) == NOPOS` or
`getEndPosition(file, comment, subtree) == NOPOS`

In addition, the following must hold:

`getStartPosition(file, comment, tree) <= getEndPosition(file, comment, tree)` or
`getStartPosition(file, comment, tree) == NOPOS` or
`getEndPosition(file, comment, tree) == NOPOS`

Parameters:
  `file` - compilation unit in which to find tree
  `comment` - the comment tree that encloses the tree for which the position is being sought
  `tree` - tree for which a position is sought
Returns:
  the end position of tree

### getEndPosition

long getEndPosition(DocCommentTree comment, DocTree tree)
Returns the ending position of the given `Tree`. If the ending position is not available, returns `Diagnostic.NOPOS`.

The given tree should be under the given comment tree. The returned position must be at the end of the yield of this tree, that is for any sub-tree of this tree, the following must hold:

`getEndPosition(comment, tree) >= getEndPosition(comment, subtree)` or
`getEndPosition(comment, tree) == NOPOS` or
`getEndPosition(comment, subtree) == NOPOS`

In addition, the following must hold:

`getStartPosition(comment, tree) <= getEndPosition(comment, tree)` or
`getStartPosition(comment, tree) == NOPOS` or
`getEndPosition(comment, tree) == NOPOS`

Parameters:
  `comment` - the comment tree that encloses the tree for which the position is being sought
  `tree` - tree for which a position is sought
Returns:
  the ending position of the given `Tree`. If the ending position is not available, returns `Diagnostic.NOPOS`
Since:
  27